/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the GroupAuthorization type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GroupAuthorization{}

// GroupAuthorization struct for GroupAuthorization
type GroupAuthorization struct {
	GroupId       *string `json:"groupId,omitempty"`
	ApplicationId *string `json:"applicationId,omitempty"`
	Builtin       *bool   `json:"builtin,omitempty"`
}

// NewGroupAuthorization instantiates a new GroupAuthorization object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGroupAuthorization() *GroupAuthorization {
	this := GroupAuthorization{}
	return &this
}

// NewGroupAuthorizationWithDefaults instantiates a new GroupAuthorization object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGroupAuthorizationWithDefaults() *GroupAuthorization {
	this := GroupAuthorization{}
	return &this
}

// GetGroupId returns the GroupId field value if set, zero value otherwise.
func (o *GroupAuthorization) GetGroupId() string {
	if o == nil || IsNil(o.GroupId) {
		var ret string
		return ret
	}
	return *o.GroupId
}

// GetGroupIdOk returns a tuple with the GroupId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupAuthorization) GetGroupIdOk() (*string, bool) {
	if o == nil || IsNil(o.GroupId) {
		return nil, false
	}
	return o.GroupId, true
}

// HasGroupId returns a boolean if a field has been set.
func (o *GroupAuthorization) HasGroupId() bool {
	if o != nil && !IsNil(o.GroupId) {
		return true
	}

	return false
}

// SetGroupId gets a reference to the given string and assigns it to the GroupId field.
func (o *GroupAuthorization) SetGroupId(v string) {
	o.GroupId = &v
}

// GetApplicationId returns the ApplicationId field value if set, zero value otherwise.
func (o *GroupAuthorization) GetApplicationId() string {
	if o == nil || IsNil(o.ApplicationId) {
		var ret string
		return ret
	}
	return *o.ApplicationId
}

// GetApplicationIdOk returns a tuple with the ApplicationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupAuthorization) GetApplicationIdOk() (*string, bool) {
	if o == nil || IsNil(o.ApplicationId) {
		return nil, false
	}
	return o.ApplicationId, true
}

// HasApplicationId returns a boolean if a field has been set.
func (o *GroupAuthorization) HasApplicationId() bool {
	if o != nil && !IsNil(o.ApplicationId) {
		return true
	}

	return false
}

// SetApplicationId gets a reference to the given string and assigns it to the ApplicationId field.
func (o *GroupAuthorization) SetApplicationId(v string) {
	o.ApplicationId = &v
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *GroupAuthorization) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GroupAuthorization) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *GroupAuthorization) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *GroupAuthorization) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o GroupAuthorization) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GroupAuthorization) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.GroupId) {
		toSerialize["groupId"] = o.GroupId
	}
	if !IsNil(o.ApplicationId) {
		toSerialize["applicationId"] = o.ApplicationId
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableGroupAuthorization struct {
	value *GroupAuthorization
	isSet bool
}

func (v NullableGroupAuthorization) Get() *GroupAuthorization {
	return v.value
}

func (v *NullableGroupAuthorization) Set(val *GroupAuthorization) {
	v.value = val
	v.isSet = true
}

func (v NullableGroupAuthorization) IsSet() bool {
	return v.isSet
}

func (v *NullableGroupAuthorization) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGroupAuthorization(val *GroupAuthorization) *NullableGroupAuthorization {
	return &NullableGroupAuthorization{value: val, isSet: true}
}

func (v NullableGroupAuthorization) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGroupAuthorization) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
